#ifndef __LCD_GFX_INCLUDED__
#define __LCD_GFX_INCLUDED__

#include <stdint.h>

void lcd_init();
void lcd_deinit();

// FB related
void lcd_show(int buffer=-1);
void lcd_animate(int delaySteps);
void lcd_picture_mode();
void lcd_set_size(int w, int h);
int lcd_get_fb_width();
int lcd_get_fb_height();

// Functions that impact how the FB is show()n
void lcd_scroll(int x=1, int y=0);
void lcd_scroll_to(int x, int y); 
void lcd_rotate(int degrees);
void lcd_wrap(bool wrap_x, bool wrap_y);

// Drawing functions
void lcd_set_pixel(int x, int y, float brightness);
void lcd_fill(float brightness, int x, int y, int w, int h);
void lcd_clear();
void lcd_draw_char(int x, int y, uint8_t ch, float brightness, bool reverse_video);
void lcd_draw_string(const char *str, int x, int y, float brightness, bool horizontal=true, bool reverse_video=false); 

// Query functions
uint8_t lcd_get_pixel(int x, int y);

#endif
