from glob import glob
import sys
import string

outFilePrefix = "lcd_font"

tFontHeader = """
#ifndef __LCD_FONT_INCLUDED__
#define __LCD_FONT_INCLUDED__

#include <stdint.h>

typedef struct {
        int width, height;
        const uint8_t *data;
} FontChar;

typedef struct {
	int width, height;
	FontChar charData[256];
} Font;

"""

tFontCData = """
#include "%s.h"

"""%(outFilePrefix)

tFontCreator = ""

for fname in glob(sys.argv[1]+'/fonts/font*.py'):
	print fname
	fontInfo = {}
	execfile(fname, fontInfo)
	fw = fontInfo['width']
	fh = fontInfo['height']
	data = fontInfo['data']

	fontName = fname.split('/')[-1][:-3]

	for idx in data:
		chData = reduce(lambda x,y:x+y, data[idx])
		tFontCData += "static const uint8_t %s_ch%d[] = { %s };\n"%(fontName, idx, string.join(map(lambda x:str(x), chData),","))

	tFontHeader += "extern Font %s;\n"%(fontName)
	tFontCreator += "Font %s = {\n"%(fontName)
	tFontCreator += "%d, %d, \n"%(fw, fh)
	tFontCreator += "{\n"
	for idx in range(256):
		if data.has_key(idx):
			tFontCreator += "\t{%d, %d, %s_ch%d},\n"%(len(data[idx][-1]), len((data[idx])), fontName, idx)
		else:
			tFontCreator += "\t{0,0,0},\n"
	tFontCreator += "}\n"
	tFontCreator += "};\n"

tFontHeader += "#endif"

f = open("%s.h"%(outFilePrefix),'w')
print >>f, tFontHeader
f.close()

f = open("%s.cpp"%(outFilePrefix),'w')
print >>f, "/* Data for all font characters */"
print >>f, tFontCData
print >>f, "/* Font definitions - includes all fonts & data above */"
print >>f, tFontCreator
f.close()
